-- phpMyAdmin SQL Dump
-- version 3.1.3.1
-- http://www.phpmyadmin.net
--
-- Serveur: localhost
-- Gnr le : Dim 10 Janvier 2010  14:18
-- Version du serveur: 5.1.33
-- Version de PHP: 5.2.9

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Base de donnes: `proman`
--
DROP DATABASE IF EXISTS `proman`;
CREATE DATABASE `proman` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;
USE `proman`;

-- --------------------------------------------------------

--
-- Structure de la table `P_Logs`
--

DROP TABLE IF EXISTS `P_Logs`;
CREATE TABLE IF NOT EXISTS `P_Logs` (
  `PLog_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `PProc_ID_FK` int(11) NOT NULL,
  `PTask_ID_FK` int(11) NOT NULL,
  `PLog_DateTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `UG_ID_FK` int(11) NOT NULL,
  `PLog_Title` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `PLog_LogText` varchar(1000) COLLATE utf8_unicode_ci NOT NULL,
  `PLog_TimeSpent` int(11) NOT NULL,
  PRIMARY KEY (`PLog_ID_PK`),
  KEY `PProc_ID_FK` (`PProc_ID_FK`),
  KEY `UG_ID_FK` (`UG_ID_FK`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `P_LogsUploads`
--

DROP TABLE IF EXISTS `P_LogsUploads`;
CREATE TABLE IF NOT EXISTS `P_LogsUploads` (
  `PLU_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `PLog_ID_FK` int(11) NOT NULL,
  `PHPFileName` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `OriginalFileName` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`PLU_ID_PK`),
  KEY `PLog_ID_FK` (`PLog_ID_FK`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `P_Process`
--

DROP TABLE IF EXISTS `P_Process`;
CREATE TABLE IF NOT EXISTS `P_Process` (
  `PProc_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `TProc_ID_FK` int(11) NOT NULL,
  `PProc_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `PProc_Description` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `PProc_Status` int(11) NOT NULL,
  `PProc_Auto_Start` tinyint(1) NOT NULL DEFAULT '0',
  `PProc_Scheduled_Start_DateTime` datetime NOT NULL,
  `PProc_Scheduled_End_DateTime` datetime NOT NULL,
  `PProc_Actual_Start_DateTime` datetime NOT NULL,
  `PProc_Actual_End_DateTime` datetime NOT NULL,
  `PProc_Visibility` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`PProc_ID_PK`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `P_Tasks`
--

DROP TABLE IF EXISTS `P_Tasks`;
CREATE TABLE IF NOT EXISTS `P_Tasks` (
  `PTask_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `PProc_ID_FK` int(11) NOT NULL,
  `TTask_ID_FK` int(11) NOT NULL,
  `PTask_Status` int(11) NOT NULL,
  `PTask_Scheduled_Start_DateTime` datetime NOT NULL,
  `PTask_Scheduled_End_DateTime` datetime NOT NULL,
  `PTask_Actual_Start_DateTime` datetime NOT NULL,
  `PTask_Actual_End_DateTime` datetime NOT NULL,
  `PTask_MPC` int(11) NOT NULL DEFAULT '0',
  `PTask_Test` varchar(500) COLLATE utf8_unicode_ci DEFAULT '1',
  `PTask_Test_Result` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`PTask_ID_PK`),
  KEY `PProc_ID_FK` (`PProc_ID_FK`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `P_TasksUsers`
--

DROP TABLE IF EXISTS `P_TasksUsers`;
CREATE TABLE IF NOT EXISTS `P_TasksUsers` (
  `PProc_ID_FK` int(11) NOT NULL,
  `TTask_ID_FK` int(11) NOT NULL,
  `UG_ID_FK` int(11) NOT NULL,
  PRIMARY KEY (`PProc_ID_FK`,`TTask_ID_FK`,`UG_ID_FK`),
  KEY `UG_ID_FK` (`UG_ID_FK`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `P_VarVals`
--

DROP TABLE IF EXISTS `P_VarVals`;
CREATE TABLE IF NOT EXISTS `P_VarVals` (
  `PVV_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `PProc_ID_FK` int(11) NOT NULL,
  `TVar_ID_FK` int(11) NOT NULL,
  `PVV_Value` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`PVV_ID_PK`),
  KEY `PProc_ID_FK` (`PProc_ID_FK`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `SystemLogs`
--

DROP TABLE IF EXISTS `SystemLogs`;
CREATE TABLE IF NOT EXISTS `SystemLogs` (
  `SL_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `SL_By_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `SL_Type` varchar(10) COLLATE utf8_unicode_ci NOT NULL,
  `SL_Application` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `SL_Description` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `SL_DateTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`SL_ID_PK`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_Docs`
--

DROP TABLE IF EXISTS `T_Docs`;
CREATE TABLE IF NOT EXISTS `T_Docs` (
  `TDoc_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `TProc_ID_FK` int(11) NOT NULL,
  `TDoc_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `TDoc_Description` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `TDoc_Link` varchar(260) COLLATE utf8_unicode_ci NOT NULL,
  `TDoc_Type` int(11) NOT NULL,
  `PHPFileName` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`TDoc_ID_PK`),
  UNIQUE KEY `TProc_ID_FK_2` (`TProc_ID_FK`,`TDoc_Name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


--
-- Structure de la table `T_NextTasks`
--

DROP TABLE IF EXISTS `T_NextTasks`;
CREATE TABLE IF NOT EXISTS `T_NextTasks` (
  `CurrentTask_ID` int(11) NOT NULL,
  `NextTask_ID` int(11) NOT NULL,
  `ifcondition` int(11) NOT NULL,
  PRIMARY KEY (`CurrentTask_ID`,`NextTask_ID`,`ifcondition`),
  KEY `NextTask_ID` (`NextTask_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_Process`
--

DROP TABLE IF EXISTS `T_Process`;
CREATE TABLE IF NOT EXISTS `T_Process` (
  `TProc_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `TProc_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `TProc_Description` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `TProc_Duration` int(11) NOT NULL DEFAULT '0',
  `TProc_Visibility` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`TProc_ID_PK`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_ProcessManagers`
--

DROP TABLE IF EXISTS `T_ProcessManagers`;
CREATE TABLE IF NOT EXISTS `T_ProcessManagers` (
  `TProc_ID_FK` int(11) NOT NULL,
  `UG_ID_FK` int(11) NOT NULL,
  PRIMARY KEY (`TProc_ID_FK`,`UG_ID_FK`),
  KEY `UG_ID_FK` (`UG_ID_FK`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_Tasks`
--

DROP TABLE IF EXISTS `T_Tasks`;
CREATE TABLE IF NOT EXISTS `T_Tasks` (
  `TTask_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `TProc_ID_FK` int(11) NOT NULL,
  `TTask_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `TTask_Description` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `TTask_Type` int(11) NOT NULL DEFAULT '0',
  `TTask_Test` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `TTask_Duration` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`TTask_ID_PK`),
  UNIQUE KEY `TProc_ID_FK` (`TProc_ID_FK`,`TTask_Name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


--
-- Structure de la table `T_TasksDocs`
--

DROP TABLE IF EXISTS `T_TasksDocs`;
CREATE TABLE IF NOT EXISTS `T_TasksDocs` (
  `TTask_ID_FK` int(11) NOT NULL,
  `TDoc_ID_FK` int(11) NOT NULL,
  PRIMARY KEY (`TTask_ID_FK`,`TDoc_ID_FK`),
  KEY `TDoc_ID_FK` (`TDoc_ID_FK`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_TasksUsers`
--

DROP TABLE IF EXISTS `T_TasksUsers`;
CREATE TABLE IF NOT EXISTS `T_TasksUsers` (
  `TTask_ID_FK` int(11) NOT NULL,
  `UG_ID_FK` int(11) NOT NULL,
  PRIMARY KEY (`TTask_ID_FK`,`UG_ID_FK`),
  KEY `UG_ID_FK` (`UG_ID_FK`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_TasksVars`
--

DROP TABLE IF EXISTS `T_TasksVars`;
CREATE TABLE IF NOT EXISTS `T_TasksVars` (
  `TTask_ID_FK` int(11) NOT NULL,
  `TVar_ID_FK` int(11) NOT NULL,
  PRIMARY KEY (`TTask_ID_FK`,`TVar_ID_FK`),
  KEY `TVar_ID_FK` (`TVar_ID_FK`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `T_Vars`
--

DROP TABLE IF EXISTS `T_Vars`;
CREATE TABLE IF NOT EXISTS `T_Vars` (
  `TVar_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `TProc_ID_FK` int(11) NOT NULL,
  `TVar_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `TVar_SI` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `TVar_Description` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  `TVar_Type` int(11) NOT NULL,
  `TVar_Unit` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `TVar_InputType` int(11) NOT NULL DEFAULT '0',
  `TVar_DropDownValues` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`TVar_ID_PK`),
  UNIQUE KEY `TProc_ID_FK` (`TProc_ID_FK`,`TVar_Name`),
  UNIQUE KEY `TProc_ID_FK_2` (`TProc_ID_FK`,`TVar_SI`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Structure de la table `UsersAndGroups`
--

DROP TABLE IF EXISTS `UsersAndGroups`;
CREATE TABLE IF NOT EXISTS `UsersAndGroups` (
  `UG_ID_PK` int(11) NOT NULL AUTO_INCREMENT,
  `UG_Group` tinyint(4) NOT NULL DEFAULT '0',
  `UG_Name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `Password` varchar(32) COLLATE utf8_unicode_ci NOT NULL,
  `UG_Email` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `UG_FullName` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `UG_Description` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`UG_ID_PK`),
  UNIQUE KEY `UG_Name` (`UG_Name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Contenu de la table `UsersAndGroups`
--

INSERT INTO `UsersAndGroups` (`UG_ID_PK`, `UG_Group`, `UG_Name`, `Password`, `UG_Email`, `UG_FullName`, `UG_Description`) VALUES
(-1, 0, 'SYSTEM', '', '', '', ''),
(1, 1, 'Administrators', '', '', '', 'System group, cannot be deleted'),
(2, 0, 'Admin', '1fa0f7cf6fa623a5b1967fd9de1db0b8', '', '', 'First Admin');


--
-- Structure de la table `UsersInGroups`
--

DROP TABLE IF EXISTS `UsersInGroups`;
CREATE TABLE IF NOT EXISTS `UsersInGroups` (
  `UserID` int(11) NOT NULL,
  `GroupID` int(11) NOT NULL,
  PRIMARY KEY (`UserID`,`GroupID`),
  KEY `GroupID` (`GroupID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Contenu de la table `UsersInGroups`
--

INSERT INTO `UsersInGroups` (`UserID`, `GroupID`) VALUES
(2, 1);

--
-- Contraintes pour les tables exportes
--

--
-- Contraintes pour la table `P_Logs`
--
ALTER TABLE `P_Logs`
  ADD CONSTRAINT `P_Logs_ibfk_1` FOREIGN KEY (`PProc_ID_FK`) REFERENCES `P_Process` (`PProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `P_Logs_ibfk_2` FOREIGN KEY (`UG_ID_FK`) REFERENCES `UsersAndGroups` (`UG_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `P_LogsUploads`
--
ALTER TABLE `P_LogsUploads`
  ADD CONSTRAINT `P_LogsUploads_ibfk_1` FOREIGN KEY (`PLog_ID_FK`) REFERENCES `P_Logs` (`PLog_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `P_Tasks`
--
ALTER TABLE `P_Tasks`
  ADD CONSTRAINT `P_Tasks_ibfk_1` FOREIGN KEY (`PProc_ID_FK`) REFERENCES `P_Process` (`PProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `P_TasksUsers`
--
ALTER TABLE `P_TasksUsers`
  ADD CONSTRAINT `P_TasksUsers_ibfk_1` FOREIGN KEY (`PProc_ID_FK`) REFERENCES `P_Process` (`PProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `P_TasksUsers_ibfk_2` FOREIGN KEY (`UG_ID_FK`) REFERENCES `UsersAndGroups` (`UG_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `P_VarVals`
--
ALTER TABLE `P_VarVals`
  ADD CONSTRAINT `P_VarVals_ibfk_1` FOREIGN KEY (`PProc_ID_FK`) REFERENCES `P_Process` (`PProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_Docs`
--
ALTER TABLE `T_Docs`
  ADD CONSTRAINT `T_Docs_ibfk_1` FOREIGN KEY (`TProc_ID_FK`) REFERENCES `T_Process` (`TProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_NextTasks`
--
ALTER TABLE `T_NextTasks`
  ADD CONSTRAINT `T_NextTasks_ibfk_1` FOREIGN KEY (`CurrentTask_ID`) REFERENCES `T_Tasks` (`TTask_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `T_NextTasks_ibfk_2` FOREIGN KEY (`NextTask_ID`) REFERENCES `T_Tasks` (`TTask_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_ProcessManagers`
--
ALTER TABLE `T_ProcessManagers`
  ADD CONSTRAINT `T_ProcessManagers_ibfk_1` FOREIGN KEY (`TProc_ID_FK`) REFERENCES `T_Process` (`TProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `T_ProcessManagers_ibfk_2` FOREIGN KEY (`UG_ID_FK`) REFERENCES `UsersAndGroups` (`UG_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_Tasks`
--
ALTER TABLE `T_Tasks`
  ADD CONSTRAINT `T_Tasks_ibfk_1` FOREIGN KEY (`TProc_ID_FK`) REFERENCES `T_Process` (`TProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_TasksDocs`
--
ALTER TABLE `T_TasksDocs`
  ADD CONSTRAINT `T_TasksDocs_ibfk_1` FOREIGN KEY (`TTask_ID_FK`) REFERENCES `T_Tasks` (`TTask_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `T_TasksDocs_ibfk_2` FOREIGN KEY (`TDoc_ID_FK`) REFERENCES `T_Docs` (`TDoc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_TasksUsers`
--
ALTER TABLE `T_TasksUsers`
  ADD CONSTRAINT `T_TasksUsers_ibfk_1` FOREIGN KEY (`TTask_ID_FK`) REFERENCES `T_Tasks` (`TTask_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `T_TasksUsers_ibfk_2` FOREIGN KEY (`UG_ID_FK`) REFERENCES `UsersAndGroups` (`UG_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_TasksVars`
--
ALTER TABLE `T_TasksVars`
  ADD CONSTRAINT `T_TasksVars_ibfk_1` FOREIGN KEY (`TTask_ID_FK`) REFERENCES `T_Tasks` (`TTask_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `T_TasksVars_ibfk_2` FOREIGN KEY (`TVar_ID_FK`) REFERENCES `T_Vars` (`TVar_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `T_Vars`
--
ALTER TABLE `T_Vars`
  ADD CONSTRAINT `T_Vars_ibfk_1` FOREIGN KEY (`TProc_ID_FK`) REFERENCES `T_Process` (`TProc_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Contraintes pour la table `UsersInGroups`
--
ALTER TABLE `UsersInGroups`
  ADD CONSTRAINT `UsersInGroups_ibfk_1` FOREIGN KEY (`UserID`) REFERENCES `UsersAndGroups` (`UG_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `UsersInGroups_ibfk_2` FOREIGN KEY (`GroupID`) REFERENCES `UsersAndGroups` (`UG_ID_PK`) ON DELETE CASCADE ON UPDATE CASCADE;

DELIMITER $$
--
-- Procdures
--
DROP PROCEDURE IF EXISTS `createPTask`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `createPTask`(IN PProcID INT, IN TTaskID INT)
BEGIN
	DECLARE done INT DEFAULT 0;
	DECLARE CurTaskID,Interv,VarType,ResTEST INT;
	DECLARE TName VARCHAR(100);
	DECLARE TEST VARCHAR(500);
	DECLARE VarVal,VarSI VARCHAR(100);
	DECLARE cur1 CURSOR FOR SELECT DISTINCT CurrentTask_ID, TTask_Test,TTask_Name,TTask_Duration
		FROM T_Tasks, T_NextTasks
		WHERE TTask_ID_PK = CurrentTask_ID
		AND TTask_ID_PK=TTaskID;
	DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
	OPEN cur1;
	REPEAT
		FETCH cur1 INTO CurTaskID,TEST,TName,Interv;
		IF NOT done THEN
			WHILE LOCATE('$', TEST)>0 DO
				SET VarSI = SUBSTRING_INDEX(SUBSTRING_INDEX(TEST, '$', 2),'$',-1);	
				SELECT P_VarVals.PVV_Value, T_Vars.TVar_Type
                                    FROM P_VarVals, T_Vars
                                    WHERE P_VarVals.PProc_ID_FK =PProcID
                                    AND T_Vars.Tvar_SI = VarSI
                                    AND P_VarVals.TVar_ID_FK = T_Vars.TVar_ID_PK
				INTO VarVal,VarType; 
				IF (VarType<3) THEN SET VarVal=CONCAT('NUM(',VarVal,')'); END IF;
				IF (VarType=3) THEN SET VarVal=CONCAT('TXT(',VarVal,')'); END IF;
				IF (VarType=4) THEN SET VarVal=CONCAT('DATE(',VarVal,')'); END IF;
				SET TEST=REPLACE(TEST, CONCAT('$',VarSI,'$'), VarVal);
			END WHILE;	
            IF (TEST='') THEN
			  SET ResTEST=0;
			ELSE
			  SET ResTEST=eval(TEST);
			END IF;
			INSERT INTO P_Tasks(PProc_ID_FK,TTask_ID_FK,PTask_Status,PTask_Scheduled_Start_DateTime,PTask_Scheduled_End_DateTime,PTask_MPC,PTask_Test,PTask_Test_Result) VALUES(PProcID,CurTaskID,0,Now(),DATE_ADD(NOW(), INTERVAL Interv SECOND),0,TEST,ResTEST);
			INSERT INTO P_Logs(PProc_ID_FK,PTask_ID_FK,UG_ID_FK,PLog_Title,PLog_LogText,PLog_TimeSpent) VALUES(PProcID,LAST_INSERT_ID(),-1,'Task created','Task created automatically by the PROCESS ENGINE',0);
		END IF;	
	UNTIL done END REPEAT;
    CLOSE cur1;	
END$$

DROP PROCEDURE IF EXISTS `StartAutoStartProcesses`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `StartAutoStartProcesses`()
BEGIN
	DECLARE done, PID INT DEFAULT 0;
	DECLARE PNAME VARCHAR(500) DEFAULT '';
	DECLARE cur1 CURSOR FOR SELECT	PProc_ID_PK, PProc_Name
	  FROM  P_Process
	  WHERE PProc_Status=0
	  AND PProc_Scheduled_Start_DateTime <= Now( ) 
	  AND PProc_Auto_Start =1;
	DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
	OPEN cur1;
	REPEAT
    FETCH cur1 INTO PID,PNAME;
    IF NOT done THEN
		UPDATE P_Process 
			SET PProc_Status=1, PProc_Actual_Start_DateTime=Now()
			WHERE PProc_ID_PK=PID;
		INSERT INTO P_Logs(PProc_ID_FK,PTask_ID_FK,UG_ID_FK,PLog_Title,PLog_LogText,PLog_TimeSpent) VALUES(PID,-1,-1,'Process is scheduled','Process scheduled automatically by the PROCESS ENGINE',0);
   END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;	  
END$$

DROP PROCEDURE IF EXISTS `StartFirstTasks`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `StartFirstTasks`()
BEGIN
  DECLARE done INT DEFAULT 0;
  DECLARE PID,TID INT;
  DECLARE cur1 CURSOR FOR Select P_Process.PProc_ID_PK,T_NextTasks.NextTask_ID			
			from P_Process,T_Tasks,T_NextTasks
			where P_Process.PProc_Status=1
			and P_Process.PProc_ID_PK NOT IN (Select P_Tasks.PProc_ID_FK from P_Tasks)
			and T_Tasks.TProc_ID_FK=P_Process.TProc_ID_FK
			and T_NextTasks.CurrentTask_ID=T_Tasks.TTask_ID_PK
			and T_Tasks.TTask_type=-1;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;
  REPEAT
    FETCH cur1 INTO PID,TID;
    IF NOT done THEN
	  CALL CreatePTask(PID,TID);
    END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;
END$$

DROP PROCEDURE IF EXISTS `StartNextTasksOfStandardTask`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `StartNextTasksOfStandardTask`()
BEGIN
  DECLARE done,CurPID,CurTID INT DEFAULT 0;
  DECLARE PID,TID,PTID,MC INT;
  DECLARE cur1 CURSOR FOR SELECT P_Process.PProc_ID_PK,T_NextTasks.NextTask_ID,P_Tasks.PTask_ID_PK
 		from P_Process,T_NextTasks,P_Tasks,T_Tasks
		where P_Tasks.PProc_ID_FK=P_Process.PProc_ID_PK
		and P_Tasks.TTask_ID_FK=T_Tasks.TTask_ID_PK
		and T_Tasks.TTask_ID_PK=T_NextTasks.CurrentTask_ID
		and P_Process.PProc_Status=1
		and P_Tasks.PTask_Status=3
		and P_Tasks.PTask_MPC=0
		and T_Tasks.TTask_Type=0
		and (SELECT COUNT(PT.TTask_ID_FK )=0
			FROM P_Tasks as PT, T_NextTasks as TN
			WHERE PT.TTask_ID_FK = TN.CurrentTask_ID
			AND TN.NextTask_ID =T_NextTasks.NextTask_ID
			AND PT.PProc_ID_FK=P_Process.PProc_ID_PK
			AND PT.PTask_Status <>3) 
		ORDER BY P_Process.PProc_ID_PK, T_NextTasks.NextTask_ID;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;
  REPEAT
    FETCH cur1 INTO PID,TID,PTID;
    IF NOT done THEN
		IF (curTID<>TID OR curPID<>PID) THEN
			CALL CreatePTask(PID,TID);
			SET curTID=TID;
			SET curPID=PID;
		END IF; 	
		UPDATE P_Tasks SET P_Tasks.PTask_MPC=1 WHERE P_Tasks.PTask_ID_PK=PTID;
    END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;
END$$

DROP PROCEDURE IF EXISTS `StartNextTasksOfTestTask`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `StartNextTasksOfTestTask`()
BEGIN
  DECLARE done, curPID, curTID INT DEFAULT 0;
  DECLARE PID,TID,PTID,ifCon INT;
  DECLARE TEST VARCHAR(500);
  DECLARE cur1 CURSOR FOR SELECT P_Process.PProc_ID_PK, T_NextTasks.NextTask_ID, P_Tasks.PTask_ID_PK
		FROM P_Process, T_NextTasks, P_Tasks, T_Tasks
		WHERE P_Tasks.PProc_ID_FK = P_Process.PProc_ID_PK
		AND P_Tasks.TTask_ID_FK = T_Tasks.TTask_ID_PK
		AND T_Tasks.TTask_ID_PK = T_NextTasks.CurrentTask_ID
		AND P_Process.PProc_Status =1
		AND P_Tasks.PTask_Status =0
		AND P_Tasks.PTask_MPC =0
		AND T_Tasks.TTask_Type =1
		AND T_NextTasks.ifcondition = P_Tasks.PTask_Test_Result
		and (SELECT COUNT(PT.TTask_ID_FK )=0
			FROM P_Tasks as PT, T_NextTasks as TN, T_Tasks as TT
			WHERE PT.TTask_ID_FK = TN.CurrentTask_ID
			AND TN.NextTask_ID =T_NextTasks.NextTask_ID
			AND TT.TTask_type<>1
			AND TT.TTask_ID_PK=PT.TTask_ID_FK		
			AND PT.PProc_ID_FK=P_Process.PProc_ID_PK
			AND PT.PTask_Status <>3)
		ORDER BY P_Process.PProc_ID_PK, T_NextTasks.NextTask_ID;		
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;
  REPEAT
    FETCH cur1 INTO PID,TID,PTID;
    IF NOT done THEN
		IF (curTID<>TID OR curPID<>PID) THEN
			CALL CreatePTask(PID,TID);
			SET curTID=TID;
			SET curPID=PID;
		END IF;	
		UPDATE P_Tasks SET P_Tasks.PTask_MPC=1,P_Tasks.PTask_Status=3 WHERE P_Tasks.PTask_ID_PK=PTID;
    END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;
END$$

DROP PROCEDURE IF EXISTS `StartNextTasksOfWaitTask`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `StartNextTasksOfWaitTask`()
BEGIN
  DECLARE done, curPID, curTID, ResTEST INT DEFAULT 0;
  DECLARE PID,TID,PTID,ifCon INT;
  DECLARE TEST VARCHAR(1024);
  DECLARE cur1 CURSOR FOR SELECT P_Process.PProc_ID_PK, T_NextTasks.NextTask_ID, P_Tasks.PTask_ID_PK, P_Tasks.PTask_Test
		FROM P_Process, T_NextTasks, P_Tasks, T_Tasks
		WHERE P_Tasks.PProc_ID_FK = P_Process.PProc_ID_PK
		AND P_Tasks.TTask_ID_FK = T_Tasks.TTask_ID_PK
		AND T_Tasks.TTask_ID_PK = T_NextTasks.CurrentTask_ID
		AND P_Process.PProc_Status =1
		AND P_Tasks.PTask_Status =0
		AND P_Tasks.PTask_MPC =0
		AND T_Tasks.TTask_Type =2
		and (SELECT COUNT(PT.TTask_ID_FK )=0
			FROM P_Tasks as PT, T_NextTasks as TN, T_Tasks as TT
			WHERE PT.TTask_ID_FK = TN.CurrentTask_ID
			AND TN.NextTask_ID =T_NextTasks.NextTask_ID
			AND TT.TTask_type<>2
			AND TT.TTask_ID_PK=PT.TTask_ID_FK		
			AND PT.PProc_ID_FK=P_Process.PProc_ID_PK
			AND PT.PTask_Status <>3)
		ORDER BY P_Process.PProc_ID_PK, T_NextTasks.NextTask_ID;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;
  REPEAT
    FETCH cur1 INTO PID,TID,PTID,TEST;
    IF NOT done THEN
		SET ResTEST=eval(TEST);
		IF (ResTEST=1) THEN
			IF (curTID<>TID OR curPID<>PID) THEN
				CALL CreatePTask(PID,TID);
				SET curTID=TID;
				SET curPID=PID;
			END IF;	
			UPDATE P_Tasks SET P_Tasks.PTask_MPC=1,P_Tasks.PTask_Status=3 WHERE P_Tasks.PTask_ID_PK=PTID;
		END IF;	
    END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;
END$$

DROP PROCEDURE IF EXISTS `TerminateProcesses`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `TerminateProcesses`()
BEGIN
  DECLARE done INT DEFAULT 0;
  DECLARE RES,PID INT;
  DECLARE cur1 CURSOR FOR Select P_Process.PProc_ID_PK 
						from P_Process
						where (Select count(allclosed.PTask_Status)=0 
							from P_Tasks as allclosed
							where allclosed.PTask_Status<>3
							and allclosed.PProc_ID_FK=P_Process.PProc_ID_PK)
						and P_Process.PProc_Status=1;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;
  OPEN cur1;
  REPEAT
    FETCH cur1 INTO PID;
    IF (NOT done) THEN
	UPDATE P_Process SET PProc_Status=3,PProc_Actual_End_DateTime=NOW()  WHERE PProc_ID_PK=PID;
	INSERT INTO P_Logs(PProc_ID_FK,PTask_ID_FK,UG_ID_FK,PLog_Title,PLog_LogText,PLog_TimeSpent) VALUES(PID,-1,-1,'Process is terminated','Process terminaded automatically by the PROCESS ENGINE',0);
    END IF;
  UNTIL done END REPEAT;
  CLOSE cur1;
END$$

--
-- Fonctions
--
DROP FUNCTION IF EXISTS `calc`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `calc`(eL NVARCHAR(128),op NVARCHAR(128), eR NVARCHAR(128)) RETURNS varchar(128) CHARSET utf8
BEGIN
DECLARE typeOP INT DEFAULT 0;
DECLARE RES,REVERS NVARCHAR(128) DEFAULT '';

IF op='=>' THEN SET op='>='; END IF;
IF op='=<' THEN SET op='<='; END IF;
IF (LOCATE('NUM(',eL)>0 OR LOCATE('NUM(',eR)>0) THEN SET typeOP=0; END IF;
IF (LOCATE('TXT(',eL)>0 OR LOCATE('TXT(',eR)>0) THEN SET typeOP=1; END IF;
IF (LOCATE('DATE(',eL)>0 OR LOCATE('DATE(',eR)>0) THEN SET typeOP=2; END IF;  
IF (LOCATE('NOW()',eL)>0 OR LOCATE('NOW()',eR)>0) THEN SET typeOP=2; END IF; 

SET eL=REPLACE(eL,'NUM(',''); 
SET eL=REPLACE(eL,'TXT(','');  
SET eL=REPLACE(eL,'DATE(',''); 
SET eL=REPLACE(eL,')','');
SET eR=REPLACE(eR,'NUM(',''); 
SET eR=REPLACE(eR,'TXT(','');  
SET eR=REPLACE(eR,'DATE(','');
SET eR=REPLACE(eR,')','');
 
IF typeOP=0 THEN
	SET @l=CAST(eL AS DECIMAL(20,10));
	SET @r=CAST(eR AS DECIMAL(20,10));
END IF;
IF typeOP=1 THEN
	SET @l=CAST(eL AS CHAR(500)); 
	SET @r=CAST(eR AS CHAR(500)); 
END IF;
IF typeOP=2 THEN
    IF (eL='NOW(') THEN SET @l=NOW(); ELSE SET @l=CAST(eL AS DATETIME); END IF;
	IF (eR='NOW(') THEN SET @r=NOW(); ELSE SET @r=CAST(eR AS DATETIME); END IF;
END IF;


IF op='+' THEN 
   IF typeOP=0 THEN SET RES=@l+@r; END IF;
   IF typeOP=1 THEN SET RES=CONCAT(@l,@r); END IF;	   
END IF;
IF op='-' THEN SET RES=(@l-@r); END IF;
IF op='*' THEN SET RES=(@l*@r); END IF;
IF op='/' THEN SET RES=(@l/@r); END IF;
IF op='AND' THEN SET RES=(@l AND @r); END IF;
IF op='OR' THEN SET RES=(@l OR @r); END IF;
IF op='>=' THEN SET RES=(@l>=@r); END IF;
IF op='<=' THEN SET RES=(@l<=@r); END IF;
IF op='<>' THEN SET RES=(@l<>@r); END IF;
IF op='>' THEN SET RES=(@l>@r); END IF;
IF op='<' THEN SET RES=(@l<@r); END IF;
IF op='=' THEN SET RES=(@l=@r); END IF;

IF ((typeOP=0) AND (op NOT IN('=','<','>','>=','<=','<>','AND','OR')))THEN
  SET RES=CAST(RES AS DECIMAL(20,10));
  SET REVERS=REVERSE(RES);
  WHILE (LOCATE('0',REVERS)=1) DO
    SET REVERS=RIGHT(REVERS,LENGTH(REVERS)-1);
  END WHILE;
  IF LOCATE('.',REVERS)=1 THEN SET REVERS=RIGHT(REVERS,LENGTH(REVERS)-1); END IF;
  SET RES=CONCAT('NUM(',REVERSE(REVERS),')');
END IF;

IF ((typeOP=1) AND (op NOT IN('=','<','>','>=','<=','<>','AND','OR')))THEN
   SET RES=CONCAT('TXT(',RES,')');	   
END IF;

RETURN RES;
END$$

DROP FUNCTION IF EXISTS `eval`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `eval`(toParse NVARCHAR(1024)) RETURNS varchar(1024) CHARSET utf8
BEGIN
DECLARE TEXT,STKOU,STKOP,RES,REVERS NVARCHAR(1024) DEFAULT '';
DECLARE pos1,pos2,pos3,pos4,ACTION,LENG INT DEFAULT 0;
DECLARE TODO,MEMO,LEXP,REXP,OPER NVARCHAR(128) DEFAULT '';

SET TEXT=toParse;
WHILE LENGTH(TEXT)>0 DO
  SET ACTION=10;
  IF LOCATE(' ',TEXT)=1 THEN SET ACTION=3; SET LENG=1; END IF;
  IF LOCATE('(',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='('; END IF;
  IF LOCATE(')',TEXT)=1 THEN SET ACTION=2; SET LENG=1; SET TODO=')'; END IF;
  IF LOCATE('+',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='+'; END IF;  
  IF LOCATE('-',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='-'; END IF; 
  IF LOCATE('*',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='*'; END IF;   
  IF LOCATE('/',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='/'; END IF; 
  IF LOCATE('AND',TEXT)=1 THEN SET ACTION=1; SET LENG=3; SET TODO='AND'; END IF;
  IF LOCATE('OR',TEXT)=1 THEN SET ACTION=1; SET LENG=2; SET TODO='OR'; END IF;  
  IF LOCATE('NUM(',TEXT)=1 THEN SET ACTION=0; SET LENG=LOCATE(')',TEXT); SET TODO=LEFT(TEXT,LENG); END IF; 
  IF LOCATE('TXT(',TEXT)=1 THEN SET ACTION=0; SET LENG=LOCATE(')',TEXT); SET TODO=LEFT(TEXT,LENG); END IF; 
  IF LOCATE('DATE(',TEXT)=1 THEN SET ACTION=0; SET LENG=LOCATE(')',TEXT); SET TODO=LEFT(TEXT,LENG); END IF; 
  IF LOCATE('NOW(',TEXT)=1 THEN SET ACTION=0; SET LENG=5; SET TODO=LEFT(TEXT,5); END IF; 
  IF LOCATE('>',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='>'; END IF; 
  IF LOCATE('<',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='<'; END IF; 
  IF LOCATE('=',TEXT)=1 THEN SET ACTION=1; SET LENG=1; SET TODO='='; END IF; 
  IF LOCATE('>=',TEXT)=1 THEN SET ACTION=1; SET LENG=2; SET TODO='>='; END IF;
  IF LOCATE('=>',TEXT)=1 THEN SET ACTION=1; SET LENG=2; SET TODO='=>'; END IF;  
  IF LOCATE('<=',TEXT)=1 THEN SET ACTION=1; SET LENG=2; SET TODO='<='; END IF;
  IF LOCATE('=<',TEXT)=1 THEN SET ACTION=1; SET LENG=2; SET TODO='=<'; END IF; 
  IF LOCATE('<>',TEXT)=1 THEN SET ACTION=1; SET LENG=2; SET TODO='<>'; END IF;  
  
  IF ACTION=10 THEN
    SET MEMO=CONCAT(MEMO,LEFT(TEXT,1));
	SET TEXT=MID(TEXT,2,LENGTH(TEXT)-1);
  ELSE
    IF MEMO<>'' THEN
		SET STKOU=CONCAT(STKOU,MEMO,'}');
		SET MEMO='';
	END IF;	
  END IF;
  IF ACTION=0 THEN
    SET STKOU=CONCAT(STKOU,TODO,'}');
	SET TEXT=MID(TEXT,LENG+1,LENGTH(TEXT)-LENG+1);
  END IF;  
  IF ACTION=1 THEN
    SET STKOP=CONCAT('{',TODO,'}',STKOP);
	SET TEXT=MID(TEXT,LENG+1,LENGTH(TEXT)-LENG+1);
  END IF;
  IF ACTION=2 THEN
	SET pos1=LOCATE('(',STKOP);
	IF pos1>0 THEN
	   SET STKOU=CONCAT(STKOU,LEFT(STKOP,pos1-2));
	   SET STKOP=MID(STKOP,pos1+2,LENGTH(STKOP)-pos1-1);
	END IF;
	SET TEXT=MID(TEXT,LENG+1,LENGTH(TEXT)-LENG+1);
  END IF;
  IF ACTION=3 THEN
	SET TEXT=MID(TEXT,LENG+1,LENGTH(TEXT)-LENG+1);
  END IF;  
END WHILE;
IF MEMO<>'' THEN
  SET STKOU=CONCAT(STKOU,MEMO,'}');  
END IF;
IF STKOP<>'' THEN
  SET STKOU=CONCAT(STKOU,STKOP); 
END IF;
WHILE LOCATE('{',STKOU)>0 DO
	SET pos1=LOCATE('{',STKOU); 
	SET pos2=LOCATE('}',STKOU,pos1+1); 
	SET REVERS=REVERSE(LEFT(STKOU,pos1-2)); 
	SET pos3=LOCATE('}',REVERS); 
	SET pos4=LOCATE('}',REVERS,pos3+1); 
	IF pos4=0 THEN SET pos4=LENGTH(REVERS)+1; END IF; 
	SET LEXP=MID(STKOU,pos1-pos4,pos4-pos3-1); 
	SET REXP=MID(STKOU,pos1-pos3,pos3-1); 
	SET OPER=MID(STKOU,pos1+1,pos2-pos1-1);  
	SET RES=calc(LEXP,OPER,REXP);
	SET STKOU=CONCAT(LEFT(STKOU,pos1-pos4-1),RES,RIGHT(STKOU,LENGTH(STKOU)-pos2+1));
END WHILE;
RETURN RES;
END$$

--
-- vnements
--

DROP EVENT IF EXISTS `PromanScheduler`$$
CREATE EVENT `PromanScheduler` ON SCHEDULE EVERY 1 MINUTE STARTS '2009-10-25 12:11:44' ON COMPLETION NOT PRESERVE ENABLE DO BEGIN
   CALL StartAutoStartProcesses();
   CALL StartFirstTasks();
   CALL StartNextTasksOfStandardTask();
   CALL StartNextTasksOfTestTask();
   CALL StartNextTasksOfWaitTask();
   CALL TerminateProcesses();  
END$$

DELIMITER ;
 