<?php
//
/*******************************************************
 **                  ProMan 				          **
 **                                                   **
 **  Copyright:         (C) 2009 - 2010 giaard        **
  *******************************************************/

/*******************************************************
 **       This file is part of ProMan    			  **
 **                                                   **
 **  ProMan is a free software. 		              **
 **  ProMan is distributed with the hope that   	  **
 **  it will be useful, but WITHOUT ANY WARRANTY.     **
 *******************************************************/
//
//
include_once('functions/authentification.php');
include_once('lang/'.$defaultLang.'/authentification.php');


$errorMessage = '';
// Test de l'envoi du formulaire
if ($_GET['action']=='pwforgotten'){
	// Le mot de passe a été oublié
	$errorMessage=$l['forgotten info'];
}
// Cas de l'authentification normale'
if(!empty($_POST) && $_GET['action']!=='pwforgotten') 
{
	// Les identifiants sont transmis ?
	if(!empty($_POST['login']) && !empty($_POST['password'])) 
	{
		$Rep=login($_POST['login'],$_POST['password']);
		if (!$Rep[0])
		{
			$errorMessage = $l['bad login'];
			addSystemLog($_SESSION['login'],'ERROR','LOGIN','Login error: bad account or password');
		}
		else
		{
			// On ouvre la session
			session_start();
			// On enregistre le login en session
			$_SESSION['login'] = $_POST['login'];
			$_SESSION['id']=$Rep[1];
			$_SESSION['superAdmin']=isSuperAdmin($Rep[1]);
			$_SESSION['Ticket']=getUserTicket($Rep[1]);
			$_SESSION['Manager']=isManager($_SESSION['Ticket']);
			if (empty($_POST['lang']))
				$_SESSION['userLang']=$defaultLang;
			else
				$_SESSION['userLang']=$_POST['lang'];
			addSystemLog($_SESSION['login'],'SUCCESS','LOGIN','Login successfull');
			header('Location: index.php');
			pexit('');
		}
	}
	else
	{
		$errorMessage = $l['empty identifier'];
	}
}
// cas de la demande de nouveau mot de passe
if(!empty($_POST) && $_GET['action']=='pwforgotten' && $_GET['request']=='true')
{
	if(empty($_POST['login']) && empty($_POST['email']))
	{
		$errorMessage = $l['id or email'];
	}
	if(!empty($_POST['login']) && !empty($_POST['email']))
	{
		$errorMessage = $l['only one'];
	}
	if ((!empty($_POST['login']) && empty($_POST['email'])) || (empty($_POST['login']) && !empty($_POST['email']))){
		// envoi nouveau mot de passe
		$pwsendet=true;
		addSystemLog($_SESSION['login'],'WARNING','LOGIN',''.$_POST['login'].''.$_POST['email'].' has requested a new password');
		$reset=sendNewPW($_POST['login'],$_POST['email']);
		
	}	
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr">
<head>
	<title><?php echo $navTitle; ?></title>
 	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
 	<link rel="stylesheet" media="screen" type="text/css" title="Design" href="layout/proman.css" />
</head>
<body>
<?php
if ($pwsendet==false){
	if ($_GET['action']=='pwforgotten')
		echo '<form action="'.htmlspecialchars("authentification.php?&action=pwforgotten&request=true").'" method="post">';
	else
		echo '<form action="'.htmlspecialchars($_SERVER['PHP_SELF']).'" method="post">';
	echo '<table class="logondialog">';	
  	echo '<tr>';
    echo '<th colspan="2" align="center" class="tablemain">';
  	echo '<h3>Identification</h3>';
	if(!empty($errorMessage)) 
  	  {
	    echo '<p class="noktext">', htmlspecialchars($errorMessage) ,'</p>';
	  }
	echo '</th>';
  	echo '</tr>';
  	echo '<tr>';
    echo '<td class="firstcellpadding">';
    echo '<label for="login">'.$l['identifier'].'</label>';
    echo '</td>';
    echo '<td class="firstcellpadding">';
    echo '<input type="text" name="login" id="login" value="" />';
    echo '</td>';
  	echo '</tr>';
    echo '<tr>';
    echo '<td class="standardcellpadding">';
    if ($_GET['action']=='pwforgotten')
   		echo '<label for="password">'.$l['email'].'</label>';
	else
	  	echo '<label for="password">'.$l['pwd'].'</label>';
    echo '</td>';
    echo '<td class="standardcellpadding">';
 	if ($_GET['action']=='pwforgotten')
		echo '<input type="email" name="email" id="email" size="40" value="" />';  	
	else
		echo '<input type="password" name="password" id="password" value="" />';					
    echo '</td>';
  	echo '</tr>';
  	
  	echo '<tr>';
    echo '<td class="standardcellpadding">';
    echo '<label for="lang">'.$l['language'].'</label>';
    echo '</td>';
    echo '<td class="standardcellpadding">';
   	echo '<select name="lang" size="1">';
   	$Languages=getLanguages();
   	for ($i=0;$i<count($Languages);$i++){
   		if (strtolower($Languages[$i])==strtolower($defaultLang))
   			$selected='selected="selected"';
		else
			$selected='';
		echo '<option value="'.$Languages[$i].'" '.$selected.'>'.$Languages[$i].'</option>';
	}
	echo '</select>';
    echo '</td>';
  	echo '</tr>';
  	echo '<tr align="CENTER">';
    echo '<td colspan="2">';
   	if ($_GET['action']=='pwforgotten')
		echo '<input type="submit" name="submit" value="'.$l['request new pwd'].'" />';
    else
		echo '<input type="submit" name="submit" value="'.$l['login'].'" />';
    echo '</td>';
    echo '</tr>';
  	echo '<tr>';
    echo '<td colspan="2" class="lastcellpadding">';
	if ($_GET['action']!=='pwforgotten')
		echo '<a href="authentification.php?&action=pwforgotten" id="loginlink">'.$l['login or pwd forgotten'].'</a>';
    echo '</td>';  
  	echo '</tr>';
	echo '</table>';
	echo'</form>';
}
else{
	echo '<table class="logondialog">';	
  	echo '<tr>';
    echo '<th align="center" class="tablemain">';
  	echo '<h3>Identification</h3>';
	if ($reset) 
	    echo '<p class="oktext">'.$l['new pwd sent'].'</p>';
	else
 		echo '<p class="noktext">'.$l['reset problem'].'</p>';
	echo '</th>';
  	echo '</tr>';
  	echo '<tr>';
    echo '<td class="lastcellpadding">';
    echo '<br/>';
	echo '<a href="authentification.php">'.$l['back to login form'].'</a>';
    echo '</td>';  
  	echo '</tr>';
  	echo '</table>';
}
?>
</body>
</html>