<?php
//
/*******************************************************
 **                  ProMan 				          **
 **                                                   **
 **  Copyright:         (C) 2009 - 2010 giaard        **
  *******************************************************/

/*******************************************************
 **       This file is part of ProMan    			  **
 **                                                   **
 **  ProMan is a free software. 		              **
 **  ProMan is distributed with the hope that   	  **
 **  it will be useful, but WITHOUT ANY WARRANTY.     **
 *******************************************************/
//
//
include_once('globals.php');


function canUserReadLog($ticket,$pid,$tid){
	// If User is Manager for a process or User in a task, he can add Logs
	$id=canUserAddLog($ticket,$pid,$tid);
	if (!empty($id)) 
		return $id;
	// If user is assigned to a task and Process Visibility is set to all users who have a task assigned
	if (!empty($pid) && empty($tid)){
		$query = sprintf("Select distinct PProc_ID_PK as ID
					from P_Process,P_TasksUsers
					where PProc_ID_PK=PProc_ID_FK
					and PProc_Visibility=1
					and PProc_ID_PK=%s
					and UG_ID_FK IN(%s)",
		mysql_real_escape_string($pid),
		mysql_real_escape_string($ticket));
		$result=exec_query($query);
		while ($row = mysql_fetch_assoc($result)) {
			$id=$row['ID'];
		}
	}
	return $id;
}

function canUserAddLog($ticket,$pid,$tid){
	if (!empty($pid) && empty($tid)){
			$query = sprintf("Select distinct PProc_ID_PK as ID
 						from P_Process,T_ProcessManagers
 						where P_Process.TProc_ID_FK=T_ProcessManagers.TProc_ID_FK
 						and PProc_ID_PK=%s
 						and UG_ID_FK IN(%s)",
		mysql_real_escape_string($pid),
		mysql_real_escape_string($ticket));
		$result=exec_query($query);
		while ($row = mysql_fetch_assoc($result)) {
			$id=$row['ID'];
		}
	}
	if (!empty($pid) && !empty($tid)){
			$query = sprintf("Select distinct P_Tasks.PProc_ID_FK as ID
						from P_TasksUsers,P_Tasks
						where P_Tasks.PProc_ID_FK=%s
						and P_Tasks.PTask_ID_PK=%s
						and P_Tasks.PProc_ID_FK=P_TasksUsers.PProc_ID_FK
						and P_Tasks.TTask_ID_FK=P_TasksUsers.TTask_ID_FK 
						and UG_ID_FK IN(%s)",
		mysql_real_escape_string($pid),						
		mysql_real_escape_string($tid),
		mysql_real_escape_string($ticket));
		$result=exec_query($query);
		while ($row = mysql_fetch_assoc($result)) {
			$id=$row['ID'];
			}
	}
	return $id;
}

function readLogs($pid,$tid){
	if (!empty($tid)){
		$query = sprintf("SELECT 'T' as T, TTask_Name as Name, PLog_Title as Title, PLog_LogText as Text, PLog_DateTime as DT, PLog_TimeSpent as TS, UG_Name as User,PLog_ID_PK as pid
				FROM P_Logs, UsersAndGroups, P_Tasks, T_Tasks
				WHERE P_Logs.PProc_ID_FK =%s
				AND PTask_ID_FK = %s
				AND P_Logs.UG_ID_FK = UsersAndGroups.UG_ID_PK
				AND P_Logs.PTask_ID_FK = P_Tasks.PTask_ID_PK
				AND P_Tasks.TTask_ID_FK = T_Tasks.TTask_ID_PK
				ORDER BY DT ASC",
		mysql_real_escape_string($pid),
		mysql_real_escape_string($tid));
	}
	else {
		$query = sprintf("SELECT 'T' as T, TTask_Name as Name, PLog_Title as Title, PLog_LogText as Text, PLog_DateTime as DT, PLog_TimeSpent as TS, UG_Name as User,PLog_ID_PK as pid
				FROM P_Logs, UsersAndGroups, P_Tasks, T_Tasks
				WHERE P_Logs.PProc_ID_FK =%s
				AND P_Logs.UG_ID_FK = UsersAndGroups.UG_ID_PK
				AND P_Logs.PTask_ID_FK = P_Tasks.PTask_ID_PK
				AND P_Tasks.TTask_ID_FK = T_Tasks.TTask_ID_PK
				UNION
				SELECT 'P' as T, PProc_Name as Name, PLog_Title as Title, PLog_LogText as Text, PLog_DateTime as DT, PLog_TimeSpent as TS, UG_Name as User,PLog_ID_PK as pid
				FROM P_Logs, UsersAndGroups, P_Process
				WHERE P_Logs.PProc_ID_FK =%s
				AND P_Process.PProc_ID_PK = P_Logs.PProc_ID_FK
				AND P_Logs.UG_ID_FK = UsersAndGroups.UG_ID_PK
				AND PTask_ID_FK=-1
				ORDER BY DT ASC",
		mysql_real_escape_string($pid),
		mysql_real_escape_string($pid));		
	}
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)){
		$temp=array();
		array_push($temp,
				$row['T'],
				$row['Name'],
				$row['Title'],
				$row['Text'],
				$row['DT'],
				$row['TS'],				
				$row['User'],
				$row['pid']);
		array_push($Values,$temp);
		}
	mysql_free_result($result);
	Return($Values);
}


Function getSysLogsRowCount(){
	$query = "SELECT count(SL_ID_PK) as con FROM SystemLogs";
	$result=exec_query($query);
	while ($row = mysql_fetch_assoc($result)) {
		$Value=$row['con'];
	}
	mysql_free_result($result);
	return $Value;	
}

function readSysLogs($fRow,$cRow){
	$query =sprintf("SELECT SL_DateTime, SL_By_Name, SL_Type, SL_Application, SL_Description
			FROM SystemLogs
			ORDER BY SL_DateTime DESC LIMIT %s,%s",
		mysql_real_escape_string($fRow),
		mysql_real_escape_string($cRow));				
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)){
		$temp=array();
		if ($row['SL_Type']=="SUCCESS") 
			$image='<img src="layout/log_success.gif" border="0" Style="padding-right:5px;padding-left:10px" />';
		if ($row['SL_Type']=="WARNING") 
			$image='<img src="layout/log_warning.gif" border="0" Style="padding-right:5px;padding-left:10px" />';			
		if ($row['SL_Type']=="ERROR") 
			$image='<img src="layout/log_error.gif" border="0" Style="padding-right:5px;padding-left:10px" />';		
		array_push($temp,
				'<img src="layout/cal.gif" border="0" Style="padding-right:5px;padding-left:10px" />'.$row['SL_DateTime'],
				'<img src="layout/users.gif" border="0" Style="padding-right:5px;padding-left:10px" />'.$row['SL_By_Name'],
				$image.$row['SL_Type'],
				$row['SL_Application'],
				$row['SL_Description']);
		array_push($Values,$temp);
		}
	mysql_free_result($result);
	Return($Values);
}

function getLogAttachments($pid){
		$query = sprintf("SELECT PHPFileName, OriginalFileName FROM P_LogsUploads WHERE PLog_ID_FK=%s",
				 mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)){
		$temp=array();
		//array_push($temp,'<a href="index.php?page=download&file='.$row['PHPFileName'].'&rname='.$row['OriginalFileName'].'" target="_blank" id="attachlink">'.$row['OriginalFileName'].'</a>');
		array_push($temp,'<a href="index.php?page=download&file='.$row['PHPFileName'].'" id="attachlink">'.$row['OriginalFileName'].'</a>');
		array_push($Values,$temp);
		}
	mysql_free_result($result);
	Return($Values);	
}

function uploadfile($destFolder,$tabFile,$id){
	global $l;
	$message='';
	$newName=Uniqid('PL');
	// Primo on déplace de fichier dans les uploads
	// $pathelementstmp = pathinfo($tabFile['tmp_name']);
	// print_r($pathelementstmp);
	$pathelementsori = pathinfo($tabFile['name']);
	if (move_uploaded_file($tabFile['tmp_name'],$destFolder.$newName)) {
		// Mettre à jours le lien dans la table P_LogsUploads
		addFileRef($id,$newName,$pathelementsori['basename']);
	}
	else 
        $message=$l['upload problem'];
	return $message;
}

function addFileRef($lid,$PHPFileName,$OriginalFileName){
	$query = sprintf("INSERT INTO P_LogsUploads (PLog_ID_FK,PHPFileName,OriginalFileName) 
			  VALUES (%s,'%s','%s')",
		mysql_real_escape_string($lid),                                   
		mysql_real_escape_string($PHPFileName),
		mysql_real_escape_string($OriginalFileName));
	$result=exec_query($query);
}

function getListOfPTasksOfPProc($pid,$orderby){
	global $l;
	$query = sprintf("SELECT DISTINCT PTask_ID_PK, TTask_Name, PTask_Status,
		PTask_Scheduled_Start_DateTime,	PTask_Scheduled_End_DateTime, PTask_Actual_Start_DateTime, PTask_Actual_End_DateTime
		FROM P_Process, P_Tasks, T_Tasks
		WHERE P_Process.PProc_ID_PK = P_Tasks.PProc_ID_FK
		AND T_Tasks.TTask_ID_PK = P_Tasks.TTask_ID_FK
		AND T_Tasks.TTask_Type=0
		AND PProc_ID_PK=%s
		ORDER BY %s",
			mysql_real_escape_string($pid),
			mysql_real_escape_string($orderby),
			mysql_real_escape_string($fRow),
			mysql_real_escape_string($cRow));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)) {
		$temp=array();
		$tid=$row['PTask_ID_PK'];
		$tname=$row['TTask_Name'];
		$status=$row['PTask_Status'];
		if (DayDiff($row['PTask_Scheduled_Start_DateTime'],'')>0 and $status<3)
			$skstart='<label id="tolate">'.$row['PTask_Scheduled_Start_DateTime'].'</label>';
		else
		    $skstart=$row['PTask_Scheduled_Start_DateTime'];

		if (DayDiff($row['PTask_Scheduled_End_DateTime'],'')>0 and  $status<3)		
		    $skend='<label id="tolate">'.$row['PTask_Scheduled_End_DateTime'].'</label>';
		else
		    $skend=$row['PTask_Scheduled_End_DateTime'];
		    
		if (DayDiff($row['PTask_Scheduled_Start_DateTime'],$row['PTask_Actual_Start_DateTime'])>0) 
			$rstart='<label id="overdue">'.$row['PTask_Actual_Start_DateTime'].'</label>';
		else   
			$rstart=$row['PTask_Actual_Start_DateTime'];
			
		if (DayDiff($row['PTask_Scheduled_End_DateTime'],$row['PTask_Actual_End_DateTime'])>0) 
			$rend='<label id="overdue">'.$row['PTask_Actual_End_DateTime'].'</label>';
		else   
			$rend=$row['PTask_Actual_End_DateTime'];
			
		switch ($status) {
			case 0 :    
				$stat='<label id="tyellowlink">'.$l['scheduled'].'</label>';
				break;
			case 1 :    
				$stat='<label id="tgreenlink">'.$l['in progress'].'</label>';
				break;
			case 2 :    
				$stat='<label id="tredlink">'.$l['paused'].'</label>';
				break;
			case 3 :    
				$stat='<label id="tbluelink">'.$l['terminated'].'</label>';	
		}	
		if ($status==0) array_push($temp,$tid,$tname,$stat,$skstart,$skend,'','');
		if ($status==1) array_push($temp,$tid,$tname,$stat,$skstart,$skend,$rstart,'');
		if ($status==2) array_push($temp,$tid,$tname,$stat,$skstart,$skend,$rstart,'');
		if ($status==3) array_push($temp,$tid,$tname,$stat,$skstart,$skend,$rstart,$rend);
		array_push($Values,$temp);
	}
	mysql_free_result($result);
	Return($Values);
}

function getPProcessInfo($pid){
	global $l;
	$query = sprintf("SELECT * from P_Process WHERE PProc_ID_PK=%s",
				 mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)){
			switch ($row['PProc_Status']) {
			case 0 :    
				$stat='<label id="tyellowlink">'.$l['planned'].'</label>';
				break;
			case 1 :    
				$stat='<label id="tgreenlink">'.$l['started'].'</label>';
				break;
			case 2 :    
				$stat='<label id="tredlink">'.$l['stopped'].'</label>';
				break;
			case 3 :    
				$stat='<label id="tbluelink">'.$l['pterminated'].'</label>';
				break;	
			case 4 :    
				$stat='<label id="tbluelink">'.$l['deleted'].'</label>';
				break;					
		}
		switch ($row['PProc_Auto_Start']) {
			case 0 :    
				$auto=$l['YES'];
				break;
			case 1 :    
				$auto=$l['NO'];
				break;
		}
		array_push($Values,$row['PProc_ID_PK'],
					$row['PProc_Name'],
					$row['PProc_Description'],
					$stat,
					$auto,
					$row['PProc_Scheduled_Start_DateTime'],
					$row['PProc_Scheduled_End_DateTime'],
					$row['PProc_Actual_Start_DateTime'],
					$row['PProc_Actual_End_DateTime']					
		);
	}
	mysql_free_result($result);
	Return($Values);	
}

function getPProcVars($pid){
	$query = sprintf("SELECT DISTINCT T_Vars.TVar_ID_PK, TVar_Name, TVar_Description, TVar_Unit, P_VarVals.PVV_ID_PK, P_VarVals.PVV_Value
		FROM T_TasksVars, P_Tasks, T_Vars, P_VarVals
		WHERE P_VarVals.TVar_ID_FK = T_Vars.TVar_ID_PK 
		AND T_Vars.TVar_ID_PK = T_TasksVars.TVar_ID_FK
		AND P_Tasks.TTask_ID_FK = T_TasksVars.TTask_ID_FK
		AND P_Tasks.PProc_ID_FK=P_VarVals.PProc_ID_FK
		AND P_Tasks.PProc_ID_FK =%s",
	mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)) {
		$temp=array();
			array_push($temp,
				$row['TVar_Name'],
				$row['TVar_Description'],
				$row['PVV_Value'],
				$row['TVar_Unit']);			
		array_push($Values,$temp);	
	}
	mysql_free_result($result);
	Return($Values);	
}


function getPProcLogUsers($pid){
	$query = sprintf("SELECT DISTINCT UG_Name, UG_Email
					FROM P_Process, P_Logs, UsersAndGroups
					WHERE P_Process.PProc_ID_PK = P_Logs.PProc_ID_FK
					AND P_Logs.UG_ID_FK = UsersAndGroups.UG_ID_PK
					AND P_Process.PProc_ID_PK =%s
					AND UsersAndGroups.UG_ID_PK>0",
	mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_assoc($result)) {
		$temp=array();
			array_push($temp, $row['UG_Name'], $row['UG_Email']);
		array_push($Values,$temp);	
	}
	mysql_free_result($result);
	Return($Values);	
}

?>