<?php
//
/*******************************************************
 **                  ProMan 				          **
 **                                                   **
 **  Copyright:         (C) 2009 - 2010 giaard        **
  *******************************************************/

/*******************************************************
 **       This file is part of ProMan    			  **
 **                                                   **
 **  ProMan is a free software. 		              **
 **  ProMan is distributed with the hope that   	  **
 **  it will be useful, but WITHOUT ANY WARRANTY.     **
 *******************************************************/
//
//
function export($name,$pid){
	$res=exportTProcess($name,$pid);
}

function import($name){
	global  $l,$InOutFolder,$UploadTempFolder;
	$res='';
	// Test if file exist
	if (file_exists("./$InOutFolder/import.zip")){
		// Extract zip file	
		$zip = new ZipArchive;
		if ($zip->open("./$InOutFolder/import.zip") === TRUE) {
    		$zip->extractTo(".$InOutFolder/import");
    		$zip->close();
		} 
		else {
    		$res=$l['cannot unzip'];
		}
		// Read xml
		$doc=new DOMDocument(); 
 		if ($doc->load(".$InOutFolder/import/template.xml")){
 			echo '<h4>'.$l['import script'].'</h4>';
 			// Import Process template 
 			$templates = $doc->getElementsByTagName("process_template"); 
 			foreach ($templates as $template){
 				$descriptions= $template->getElementsByTagName( "TProc_Description" ); 
				$description= $descriptions->item(0)->nodeValue; 
 				$durations= $template->getElementsByTagName( "TProc_Duration" ); 
				$duration= $durations->item(0)->nodeValue; 
				$visibilities= $template->getElementsByTagName( "TProc_Visibility" ); 
				$visibility= $visibilities->item(0)->nodeValue; 
				$opids= $template->getElementsByTagName( "TProc_ID_PK" ); 
				$opid= $opids->item(0)->nodeValue; 				
 				$pid=addElement('T_Process',
			 				array(	'TProc_Name',
							 		'TProc_Description',
								 	'TProc_Duration',
	                                'TProc_Visibility'),
			 				array(	$name,
							 		$description,
									$duration,
									$visibility));
 				$mProcess=array($opid => $pid);
 				// import process tasks
 				$mTasks=array(); 
 				$root_tasks=$template->getElementsByTagName( "T_Tasks" );
 				foreach($root_tasks as $root_task){
					$tasks=$root_task->getElementsByTagName( "T_Task" );
					foreach($tasks as $task){
						$names= $task->getElementsByTagName( "TTask_Name" );
						$name=$names->item(0)->nodeValue;
						$descriptions=$task->getElementsByTagName( "TTask_Description" );
						$description=$descriptions->item(0)->nodeValue;
						$types=$task->getElementsByTagName( "TTask_Type" );
						$type=$types->item(0)->nodeValue;	
						$tests=$task->getElementsByTagName( "TTask_Test" );
						$test=$tests->item(0)->nodeValue;	
						$durations= $task->getElementsByTagName( "TTask_Duration" ); 
					   	$duration= $durations->item(0)->nodeValue;	
						$otids= $task->getElementsByTagName( "TTask_ID_PK" ); 
						$otid= $otids->item(0)->nodeValue;	
						$tid=addElement('T_Tasks',
				 				array(	'TProc_ID_FK',
								 		'TTask_Name',
									 	'TTask_Description',
										'TTask_Type',
										'TTask_Test',
										'TTask_Duration'),
				 				array(	$pid,
				 						$name,
								 		$description,
								 		$type,
								 		$test,
										$duration));			   
					   	$mTasks[$otid]=$tid;
					}
				}
				// Process Vars
				$mVars=array(); 
 				$root_vars=$template->getElementsByTagName( "T_Vars" );
 				foreach($root_vars as $root_var){
					$vars=$root_var->getElementsByTagName( "T_Var" );
					foreach($vars as $var){
						$names= $var->getElementsByTagName( "TVar_Name" );
						$name=$names->item(0)->nodeValue;
						$varSIs=$var->getElementsByTagName( "TVar_SI" );
						$varSI=$varSIs->item(0)->nodeValue;
						$descriptions=$var->getElementsByTagName( "TVar_Description" );
						$description=$descriptions->item(0)->nodeValue;	
						$types=$var->getElementsByTagName( "TVar_Type" );
						$type=$types->item(0)->nodeValue;	
						$units= $var->getElementsByTagName( "TVar_Unit" ); 
					   	$unit= $units->item(0)->nodeValue;	
						$inputtypes= $var->getElementsByTagName( "TVar_InputType" ); 
					   	$inputtype= $inputtypes->item(0)->nodeValue;	
						$ddvalues= $var->getElementsByTagName( "TVar_DropDownValues" ); 
					   	$ddvalue= $ddvalues->item(0)->nodeValue;						   	
					   	$ovids= $var->getElementsByTagName( "TVar_ID_PK" ); 
						$ovid= $ovids->item(0)->nodeValue;
						$vid=addElement('T_Vars',
				 				array(	'TProc_ID_FK',
								 		'TVar_Name',
									 	'TVar_SI',
										'TVar_Description',
										'TVar_Type',
										'TVar_Unit',
										'TVar_InputType',
										'TVar_DropDownValues'),
				 				array(	$pid,
				 						$name,
								 		$varSI,
								 		$description,
								 		$type,
										$unit,
										$inputtype,
										$ddvalue));			   
					   	$mVars[$ovid]=$vid;
					}
				}
				// Process Docs
				$mDocs=array(); 
 				$root_docs=$template->getElementsByTagName( "T_Docs" );
 				foreach($root_docs as $root_doc){
					$docs=$root_doc->getElementsByTagName( "T_Doc" );
					foreach($docs as $doc){
						$names= $doc->getElementsByTagName( "TDoc_Name" );
						$name=$names->item(0)->nodeValue;
						$descriptions=$doc->getElementsByTagName( "TDoc_Description" );
						$description=$descriptions->item(0)->nodeValue;
						$links=$doc->getElementsByTagName( "TDoc_Link" );
						$link=$links->item(0)->nodeValue;	
						$types= $doc->getElementsByTagName( "TDoc_Type" ); 
					   	$type= $types->item(0)->nodeValue;
						$phpfilenames= $doc->getElementsByTagName( "PHPFileName" ); 
					   	$phpfilename= $phpfilenames->item(0)->nodeValue;
						// copy the file   	
						if ($type==1){
							copy(".$InOutFolder/import/$phpfilename",".$UploadTempFolder/$phpfilename");
							echo "COPY FILE FROM .$InOutFolder/import/$phpfilename TO .$UploadTempFolder/$phpfilename".'<br/>';
						}   	
					   	$odids= $doc->getElementsByTagName( "TDoc_ID_PK" ); 
						$odid= $odids->item(0)->nodeValue;	
 						$did=addElement('T_Docs',
				 				array(	'TProc_ID_FK',
								 		'TDoc_Name',
									 	'TDoc_Description',
										'TDoc_Link',
										'TDoc_Type',
										'PHPFileName'),
				 				array(	$pid,
				 						$name,
								 		$description,
								 		$link,
										$type,
										$phpfilename));			   
					   	$mDocs[$odid]=$did;
					}
				}				
				// NextTasks
 				$root_nts=$template->getElementsByTagName( "T_NextTasks" );
 				foreach($root_nts as $root_nt){
					$nts=$root_nt->getElementsByTagName( "T_NextTask" );
					foreach($nts as $nt){
						$id1s= $nt->getElementsByTagName( "CurrentTask_ID" );
						$id1=$id1s->item(0)->nodeValue;
						$id2s= $nt->getElementsByTagName( "NextTask_ID" );
						$id2=$id2s->item(0)->nodeValue;	
						$ifconditions= $nt->getElementsByTagName( "ifcondition" );
						$ifcondition=$ifconditions->item(0)->nodeValue;	
						$id1=$mTasks[$id1];
						$id2=$mTasks[$id2]; 
 						$did=addElement('T_NextTasks',
				 				array(	'CurrentTask_ID',
								 		'NextTask_ID',
									 	'ifcondition'),
				 				array(	$id1,
				 						$id2,
								 		$ifcondition));			   
					}
				}								
				// TasksVars
 				$root_tvs=$template->getElementsByTagName( "T_TasksVars" );
 				foreach($root_tvs as $root_tv){
					$tvs=$root_tv->getElementsByTagName( "T_TasksVar" );
					foreach($tvs as $tv){
						$id1s= $tv->getElementsByTagName( "TTask_ID_FK" );
						$id1=$id1s->item(0)->nodeValue;
						$id2s= $tv->getElementsByTagName( "TVar_ID_FK" );
						$id2=$id2s->item(0)->nodeValue;	
						$id1=$mTasks[$id1];
						$id2=$mVars[$id2]; 
 						$did=addElement('T_TasksVars',
				 				array(	'TTask_ID_FK',
								 		'TVar_ID_FK'),
				 				array(	$id1,
				 						$id2));			   
					}
				}				
				// TasksDocs
				$root_tds=$template->getElementsByTagName( "T_TasksDocs" );
 				foreach($root_tds as $root_td){
					$tds=$root_td->getElementsByTagName( "T_TasksDoc" );
					foreach($tds as $td){
						$id1s= $td->getElementsByTagName( "TTask_ID_FK" );
						$id1=$id1s->item(0)->nodeValue;
						$id2s= $td->getElementsByTagName( "TDoc_ID_FK" );
						$id2=$id2s->item(0)->nodeValue;	
						$id1=$mTasks[$id1];
						$id2=$mDocs[$id2]; 
 						$did=addElement('T_TasksDocs',
				 				array(	'TTask_ID_FK',
								 		'TDoc_ID_FK'),
				 				array(	$id1,
				 						$id2));			   
					}
				}
	         }
	         echo '<br/>';
	         echo '<h4>'.$l['before start'].'</h4>';
	         echo $l['before start info1'].'<br/>';
	         echo $l['before start info2'].'<br/>'.'<br/>';	         
	         // ici encore un peu d'information concernant l'ajout et ce qu'il faut encore faire (manager,users)'
		}
 		else{
 			$res=$l['template file not exist'];	
 		}
	}
	else{
		$res=$l['import file not exist'];
	}
	return $res;
}


function exportTProcess($name,$pid){
	global  $InOutFolder,$UploadTempFolder;
	$TProcesses=getTProcess($pid);
	$TTasks=getElemfromTable($pid,'T_Tasks');
	$TVars=getElemfromTable($pid,'T_Vars');
	$TDocs=getElemfromTable($pid,'T_Docs');
	$TNextTasks=getTNext($pid);
	$TTasksVars=getTTasksVars($pid);
	$TTasksDocs=getTTasksDocs($pid);
	// If exists delete the folder
	delTree(".$InOutFolder/$name"); 
	
	// Create the folder
	if (!mkdir(".$InOutFolder/$name")){
		return  $php_errormsg;	
	}
    else{
    	// Create xml file
    	$doc = new DOMDocument();
    	$doc->formatOutput = true;
    	// Create the root
    	$r = $doc->createElement("process_template"); 
  		$doc->appendChild( $r ); 
  		// TProcesses Elements
  		// ===================
  		foreach ($TProcesses as $key => $value) {
    	    $t = $doc->createElement($key); 
  			$t->appendChild($doc->createTextNode($value)); 
  			$r->appendChild($t);
    	}
    	// T_Tasks Element
    	// ===============
    	$a= $doc->createElement("T_Tasks");
    	$r->appendChild($a);
    	foreach($TTasks as $task){
    		// T_Task Element
    		$aa=$doc->createElement("T_Task");
    		$a->appendChild($aa);
    		foreach ($task as $key => $value) {
   			  // TTasks Elements
   			  $aaa=$doc->createElement($key);
   			  $aaa->appendChild($doc->createTextNode($value));
   			  $aa->appendChild($aaa);
		    }
    	}
    	// T_Vars Element
    	// ===============
    	$b= $doc->createElement("T_Vars");
    	$r->appendChild($b);
    	foreach($TVars as $var){
    		// T_Var Element
    		$bb=$doc->createElement("T_Var");
    		$b->appendChild($bb);
    		foreach ($var as $key => $value) {
   			  // TVars Elements
   			  $bbb=$doc->createElement($key);
   			  $bbb->appendChild($doc->createTextNode($value));
   			  $bb->appendChild($bbb);
		    }
    	}    	
     	// T_Docs Element
    	// ===============
    	$c= $doc->createElement("T_Docs");
    	$r->appendChild($c);
    	foreach($TDocs as $dok){
    		// T_Var Element
    		$cc=$doc->createElement("T_Doc");
    		$c->appendChild($cc);
    		foreach ($dok as $key => $value) {
   			  // TVars Elements
   			  $ccc=$doc->createElement($key);
   			  $ccc->appendChild($doc->createTextNode($value));
   			  $cc->appendChild($ccc);
		    }
    	}    		
    	// T_NextTasks Element
    	// ===================
    	$d= $doc->createElement("T_NextTasks");
    	$r->appendChild($d);
    	foreach($TNextTasks as $ttask){
    		// T_Var Element
    		$dd=$doc->createElement("T_NextTask");
    		$d->appendChild($dd);
    		foreach ($ttask as $key => $value) {
   			  // TVars Elements
   			  $ddd=$doc->createElement($key);
   			  $ddd->appendChild($doc->createTextNode($value));
   			  $dd->appendChild($ddd);
		    }
    	}    
     	// T_TasksVars Element
    	// ===================
    	$e= $doc->createElement("T_TasksVars");
    	$r->appendChild($e);
    	foreach($TTasksVars as $ttv){
    		// T_Var Element
    		$ee=$doc->createElement("T_TasksVar");
    		$e->appendChild($ee);
    		foreach ($ttv as $key => $value) {
   			  // TVars Elements
   			  $eee=$doc->createElement($key);
   			  $eee->appendChild($doc->createTextNode($value));
   			  $ee->appendChild($eee);
		    }
    	}			   	
      	// T_TasksDocs Element
    	// ===================
    	$f= $doc->createElement("T_TasksDocs");
    	$r->appendChild($f);
    	foreach($TTasksDocs as $ttd){
    		// T_Var Element
    		$ff=$doc->createElement("T_TasksDoc");
    		$f->appendChild($ff);
    		foreach ($ttd as $key => $value) {
   			  // TVars Elements
   			  $fff=$doc->createElement($key);
   			  $fff->appendChild($doc->createTextNode($value));
   			  $ff->appendChild($fff);
		    }
    	} 
		// copy attached files
		foreach($TDocs as $dok){
			if ($dok['TDoc_Type']==1){
				copy(".$UploadTempFolder/".$dok['PHPFileName'],".$InOutFolder/$name/".$dok['PHPFileName']);
			}
		}
    	// Save xml file
    	$doc->save(".$InOutFolder/$name/template.xml");
		archive(".$InOutFolder/$name",".$InOutFolder/$name");
	
    }
   
} 

function addElement($table,$fields,$values){
	foreach ($fields as $field){
		$allfields.=mysql_real_escape_string ($field).",";
	}
	$allfields= rtrim($allfields, ",");
	foreach ($values as $value){
		$allvalues.="'".mysql_real_escape_string ($value)."',";
	}
	$allvalues= rtrim($allvalues, ",");
	$query = "INSERT INTO $table ($allfields) VALUES ($allvalues)";
	echo $query.'<br/>';
	$result=exec_query($query);
	return mysql_insert_id();
}


function getTProcess($pid){
	$query = sprintf("SELECT * from T_Process where TProc_ID_PK=%s",	
			mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
		$Values=$row;
	}
	mysql_free_result($result);
	return $Values;
}


function getTNext($pid){
	$query = sprintf("SELECT T_NextTasks . * 
						FROM T_NextTasks, T_Tasks
						WHERE TTask_ID_PK = CurrentTask_ID
						AND TProc_ID_FK =%s",	
				mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
		array_push($Values,$row);
	}
	mysql_free_result($result);
	return $Values;
}

function getTTasksVars($pid){
	$query = sprintf("SELECT T_TasksVars . * 
						FROM T_TasksVars, T_Tasks
						WHERE TTask_ID_PK = TTask_ID_FK
						AND TProc_ID_FK=%s",	
				mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
		array_push($Values,$row);
	}
	mysql_free_result($result);
	return $Values;
}

function getTTasksDocs($pid){
	$query = sprintf("SELECT T_TasksDocs . * 
						FROM T_TasksDocs, T_Tasks
						WHERE TTask_ID_PK = TTask_ID_FK
						AND TProc_ID_FK=%s",	
				mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
		array_push($Values,$row);
	}
	mysql_free_result($result);
	return $Values;
}
						
function getElemfromTable($pid,$table){
	$query = sprintf("SELECT * from %s where TProc_ID_FK=%s",	
			mysql_real_escape_string($table),
			mysql_real_escape_string($pid));
	$result=exec_query($query);
	$Values=array();
	while ($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
		array_push($Values,$row);
	}
	mysql_free_result($result);
	return $Values;	
}
	
function delTree($dir) { 
    $files = glob( $dir . '*', GLOB_MARK ); 
    foreach( $files as $file ){ 
        if( substr( $file, -1 ) == '/' ) 
            delTree( $file ); 
        else 
            unlink( $file ); 
    } 
     if (is_dir($dir)) rmdir( $dir ); 
}

function archive($archname,$toadd){
// Adding files to a .zip file, no zip file exists it creates a new ZIP file
// increase script timeout value
ini_set('max_execution_time', 10000);
// create object
$zip = new ZipArchive();
// open archive 
if ($zip->open($archname.'.zip', ZIPARCHIVE::CREATE) !== TRUE) {
	pexit ("Could not open archive");}
// initialize an iterator
// pass it the directory to be processed
$iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator("$toadd/"));
// iterate over the directory
// add each file found to the archive
foreach ($iterator as $key=>$value) {	
	$zip->addFile(realpath($key), basename($key)) or pexit ("ERROR: Could not add file: $key");}
// close and save 
$zip->close();
}


 ?>
